# -*- coding: utf-8 -*-

from __future__ import division
import creatureV2 as cr
import turtle

#settings
cr.step_cap = 200
WIDTH = 1280
HEIGHT = 800

c = cr.Creature()
tscreen = cr.Coord(WIDTH,HEIGHT)

def settings():
	''' setzt die settings in vernünftige Werte '''
	
	global WIDTH
	zoom = 1
	
	while (cr.goal["coord"][0]*1.5)//zoom > WIDTH or cr.goal["coord"][1]//zoom > HEIGHT-20:
		zoom += 1
	WIDTH = (cr.goal["coord"][0]*1.5)//zoom
	
	turtle.setup(WIDTH,HEIGHT,WIDTH/3)
	
	tscreen.width = WIDTH
	tscreen.zoom = zoom

def preparing():
	''' zeichnet die Vorarbeit '''
	
	turtle.penup()
	turtle.speed(1000)
	turtle.delay(0)
	
	for i in range(cr.goal["coord"][0]//50+1):
		turtle.goto(tscreen.sim2turt(50*i, (cr.goal["coord"][1]/cr.goal["coord"][0])*50*i))
		
		if i == 0:
			i = "Start"
			turtle.pendown()
			turtle.rt(90-cr.angle(cr.goal["coord"]))
			turtle.circle(tscreen.sim2turt(cr.goal["coord"], function="distance"))
			turtle.rt(cr.angle(cr.goal["coord"])-90)
			turtle.penup()
		elif i == cr.goal["coord"][0]//100:
			turtle.pendown()
			turtle.rt(90-cr.angle(cr.goal["coord"]))
			turtle.circle(tscreen.sim2turt(cr.goal["coord"], (50*i,(cr.goal["coord"][1]/cr.goal["coord"][0])*50*i), function="distance"))
			turtle.rt(cr.angle(cr.goal["coord"])-90)
			turtle.penup()
		elif i == cr.goal["coord"][0]//50:
			i = "Ziel"
		
		turtle.dot(5)
		turtle.write(str(i))
	
	turtle.goto(tscreen.sim2turt(0,0))
	turtle.pendown()
	turtle.speed(2)
	turtle.delay(10)

def changeGoal(x,y):
	''' ändert die Zielkoordinaten und zeichnet neu '''
	
	cr.goal["coord"] = (x,y)
	settings()
	clear()

def gogo(c=c):
	reset()
	c.appendWay()
	for e in c.briefing:
		c.nextStep(e)
		if c.stats["step_counter"] < cr.step_cap and not c.stats["dead"]:
			c.appendWay()
		
		turtle.goto(tscreen.sim2turt(c.stats["pos"]))
	
	c.stats["dead"] = True
	c.rating()

def clear():
	turtle.clear()
	preparing()

def reset():
	turtle.penup()
	turtle.delay(0)
	turtle.speed(1000)
	turtle.goto(tscreen.sim2turt(0,0))
	turtle.delay(10)
	turtle.speed(2)
	turtle.pendown()

def new():
	c = cr.Creature()
	clear()
	gogo(c)

def compare():
	c = cr.Creature()
	reset()
	gogo(c)

def erbung(n=2,s=0):
	clear()
	
	c_list = [0 for i in range(n)]
		
	c_list[0] = cr.Creature(species=s)
	
	for i,c in enumerate(c_list):
		gogo(c)
		if i == len(c_list)-1:
			break
		c_list[i+1] = cr.procreation(c)
		reset()

settings()
preparing()
